package org.jeecg.modules.ctop.controller;

import cn.com.ctop.bytedance.entity.BytedancePlanDailyReport;
import cn.com.ctop.bytedance.service.IBytedancePlanDailyReportService;
import cn.com.ctop.bytedance.service.IReportService;
import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.entity.UserAllocation;
import cn.com.ctop.common.module.mapper.CtopOauthTokenMapper;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.common.module.service.IUserAllocationService;
import cn.com.ctop.common.module.utils.CtopAdConstant;
import cn.com.ctop.common.module.utils.ResultMapUtils;
import cn.com.ctop.common.module.utils.StatusCode;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaishouInterfaceService;
import cn.com.ctop.kuaishou.modules.graphql.service.IKuaishouWebInterfaceService;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.ctop.service.ICreateInternalService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * @author jeecg-boot
 */
@RestController
@RequestMapping("/test")
@Slf4j
public class TestController {
    @Autowired
    private ICreateInternalService createInternalService;
    @Autowired
    private IKuaishouWebInterfaceService kuaishouWebInterfaceService;

    @Autowired
    private CtopOauthTokenMapper oauthTokenMapper;

    @PostMapping(value = "/create")
    public Map<String, Object> authorization(@RequestBody JSONObject jsonObject) {
        return createInternalService.createInternal(jsonObject);
    }

    @GetMapping(value = "/t")
    public String test() {
        Result<String> result = new Result<String>();
        try {
            String requestId = UUID.randomUUID().toString();
            String img = kuaishouWebInterfaceService.qrLogin(requestId);
            if (img != null) {
                result.setSuccess(true);
                result.setResult(img);
            } else {
                result.setSuccess(false);
            }
        } catch (Exception e) {
            e.printStackTrace();
            result.setSuccess(false);
        }
        return "success";
    }


    @Autowired
    private CtopOauthTokenMapper tokenMapper;
    @Autowired
    private IKuaishouInterfaceService kuaishouInterfaceService;

    @GetMapping(value = "/getGroupData")
    public String getGroupData() {


        Date endDate = new Date();
        QueryWrapper<CtopOauthToken> tokenQueryWrapper = new QueryWrapper<>();
        tokenQueryWrapper.eq("media_id", 2);
        List<CtopOauthToken> ctopOauthTokens = tokenMapper.selectList(tokenQueryWrapper);
        for (CtopOauthToken token : ctopOauthTokens) {


            for (int i = 0; i < 7; i++) {
                Date getStartDate = DateUtils.addDay(endDate, -i);

                //3：获取广告组信息数据
                kuaishouInterfaceService.getAdvertiserGroupReportHourly(token, getStartDate, getStartDate);

            }
            for (int i = 0; i < 6; i++) {
                Date getStartDate = new Date();
                Date getEndDate = new Date();
                if (i == 0) {
                    getStartDate = DateUtils.addDay(endDate, -175 + i * 30);
                    getEndDate = DateUtils.addDay(endDate, -150 + i * 30);
                } else {
                    getStartDate = DateUtils.addDay(endDate, -180 + i * 30);
                    getEndDate = DateUtils.addDay(endDate, -150 + i * 30);
                }

                //3：获取广告组信息数据
                kuaishouInterfaceService.getAdvertiserGroupReportDaily(token, getStartDate, getEndDate);

            }


        }
        return "Success";
    }

    static ExecutorService executorService = Executors.newFixedThreadPool(5);

    @GetMapping(value = "/getVideoAndImage")
    public String getVideoAndImage() {
        QueryWrapper<CtopOauthToken> tokenQueryWrapper = new QueryWrapper<>();
        tokenQueryWrapper.eq("media_id", 2);
        List<CtopOauthToken> ctopOauthTokens = tokenMapper.selectList(tokenQueryWrapper);
        for (CtopOauthToken token : ctopOauthTokens) {
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    kuaishouInterfaceService.getVideoList2(token, null, null, 1);
                    kuaishouInterfaceService.getImageList2(token, null, null, 1);
                    //   kuaishouInterfaceService.getCreativeList2(token, null, null, 1);
                }
            });

        }
        return "Success";
    }




    @GetMapping(value = "/gerCreative")
    public void gerCreative() {
        QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
        oauthTokenQueryWrapper.eq("media_id", 2);
        List<CtopOauthToken> ctopOauthTokens = oauthTokenMapper.selectList(oauthTokenQueryWrapper);
        for (CtopOauthToken token : ctopOauthTokens) {
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    try {
                        System.err.println("获取创意,accountId:" + token.getAccountId());
                        kuaishouInterfaceService.getCreativeList(token, null, null);
                        //  kuaishouInterfaceService.getVideoList2(token, null, null,1);
                        //3: 获取图片信息数据
                        // kuaishouInterfaceService.getImageList2(token, null, null,1);
                        Thread.sleep(1 * 200);
                        //  kuaishouInterfaceService.getAppList(token.getAccountId(), token.getAccessToken());
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            });
        }

    }


    @GetMapping(value = "/gerCreativeReport")
    public void gerCreativeReport() {
        Thread thread = new Thread() {
            @SneakyThrows
            @Override
            public void run() {
                SimpleDateFormat sim = new SimpleDateFormat("yyyy-MM-dd");
                Date startDate = sim.parse("2020-02-10");
                Date endDate = sim.parse("2020-02-11");
                //1:查询当日数据
                //executorService = Executors.newFixedThreadPool(3);
                QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
                oauthTokenQueryWrapper.eq("media_id", 2);
                List<CtopOauthToken> ctopOauthTokens = oauthTokenMapper.selectList(oauthTokenQueryWrapper);
                for (CtopOauthToken token : ctopOauthTokens) {
                    executorService.submit(new Runnable() {
                        @Override
                        public void run() {
                            System.err.println("创意报表accountId:" + token.getAccountId());
                            kuaishouInterfaceService.getAdvertiserCreativeReportDaily(token, startDate, endDate);
                        }
                    });


                }
            }
        };
        thread.start();
    }






    @GetMapping(value = "/gerCreativeByAccount")
    public void gerCreative(Long accountId) {
        QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
        oauthTokenQueryWrapper.eq("media_id", 2);
        oauthTokenQueryWrapper.eq("account_id", accountId);
        oauthTokenQueryWrapper.last("limit 1");
        CtopOauthToken token = oauthTokenMapper.selectOne(oauthTokenQueryWrapper);
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    try {
                        System.err.println("获取创意,accountId:" + token.getAccountId());
                        kuaishouInterfaceService.getCreativeList(token, null, null);
                        //  kuaishouInterfaceService.getVideoList2(token, null, null,1);
                        //3: 获取图片信息数据
                        // kuaishouInterfaceService.getImageList2(token, null, null,1);
                        Thread.sleep(1 * 200);
                        //  kuaishouInterfaceService.getAppList(token.getAccountId(), token.getAccessToken());
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            });


    }



    @GetMapping(value = "/gerCreativeReportByAccount")
    public void gerCreativeReportByAccount(Long accountId, String startDateStr, String endDateStr, QueryWrapper<CtopOauthToken> account_id) {
        Thread thread = new Thread() {
            @SneakyThrows
            @Override
            public void run() {
                SimpleDateFormat sim = new SimpleDateFormat("yyyy-MM-dd");
                Date startDate = sim.parse(startDateStr);
                Date endDate = sim.parse(endDateStr);
                //1:查询当日数据
                //executorService = Executors.newFixedThreadPool(3);
                QueryWrapper<CtopOauthToken> oauthTokenQueryWrapper = new QueryWrapper<>();
                oauthTokenQueryWrapper.eq("media_id", 2);
                oauthTokenQueryWrapper.eq("account_id", accountId);
                CtopOauthToken ctopOauthToken = oauthTokenMapper.selectOne(oauthTokenQueryWrapper);
                System.err.println("创意报表accountId:" + ctopOauthToken.getAccountId());
                kuaishouInterfaceService.getAdvertiserCreativeReportDaily(ctopOauthToken, startDate, endDate);


            }
        };
        thread.start();
    }

    @Autowired
    private IUserAllocationService userAllocationService;

    @Autowired
    private IBytedancePlanDailyReportService planDailyReportService;
    @Autowired
    private ICtopOauthTokenService tokenService;

    @GetMapping("formatZybData")
    public Map<String, Object> formatZybData() {
        //清洗关于作业帮数据
        //1:查询作业帮相关的用户数据
        QueryWrapper<UserAllocation> wrapper = new QueryWrapper<>();
        wrapper.eq("project_id", 215);
        List<UserAllocation> allocations = userAllocationService.list(wrapper);
        if (null != allocations && allocations.size() > 0) {
            allocations.forEach(allocation -> {
                //根据accountId和时间，查询相关的日报表信息
                QueryWrapper<BytedancePlanDailyReport> queryWrapper = new QueryWrapper<>();
                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
//                String dateString = dateFormat.format(getDate)+" 00:00:00";
                queryWrapper.eq("advertiser_id", allocation.getAccountId())
//                        .eq("stat_datetime",dateString)
                ;
                List<BytedancePlanDailyReport> bytedancePlanDailyReports = planDailyReportService.list(queryWrapper);
                if (null != bytedancePlanDailyReports && bytedancePlanDailyReports.size() > 0) {
                    bytedancePlanDailyReports.forEach(report -> {
                        String adName = report.getAdName();
                        String[] tags = adName.split("-");
                        report.setAdsense(tags[1]);
                        report.setPlanCode(tags[2]);
                        String materialName = tags[3];
                        report.setMaterialName(materialName);
                        if (materialName.contains("其他")) {
                            report.setMaterialType("其他");
                        } else if (materialName.contains("图片轮播")) {
                            report.setMaterialType("图片轮播");
                        } else if (materialName.contains("大字报")) {
                            report.setMaterialType("大字报");
                        } else if (materialName.contains("文字动画")) {
                            report.setMaterialType("文字动画");
                        } else if (materialName.contains("采访形式")) {
                            report.setMaterialType("采访形式");
                        } else if (materialName.contains("剧情")) {
                            report.setMaterialType("剧情");
                        } else if (materialName.contains("口播")) {
                            report.setMaterialType("口播");
                        } else {
                            report.setMaterialType("其他");
                        }
                        planDailyReportService.updateById(report);
                    });
                }
            });
        }
        Map<String, Object> result = new HashMap<>();
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @Autowired
    private IReportService reportService;

    @GetMapping("bytedanceHourReport")
    public Map<String, Object> testReport() {
        Map<String, Object> result = new HashMap<>();
        log.info("头条时报数据获取开始");
        Date getDate = new Date();
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("HH");
        String hour = simpleDateFormat.format(getDate);
        if (null != hour && "00".equals(hour)) {
            getDate = DateUtils.addDay(getDate, -1);
        }
        //1:查询当日数据
        List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_BYTEDANCE);
        if (null == tokens || tokens.size() <= 0) {
            log.info("定时获取头条小时数据异常：未获取到可用的token");
            ResultMapUtils.setResultMap(result, StatusCode.COMMON_PARAM_ERROR);
            return result;
        }
        executorService = Executors.newFixedThreadPool(4);
        Date finalGetDate = getDate;
        tokens.forEach(token -> {
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    //1: 获取广告主信息数据
                    reportService.getAdvertiserReport(token, finalGetDate, finalGetDate, CtopAdConstant.BYTEDANCE_REPORT_TYPE_HOURLY);
                    //2：获取广告组信息数据
                    //reportService.getAdvertiserCampaignReport(token, finalGetDate, finalGetDate, CtopAdConstant.BYTEDANCE_REPORT_TYPE_HOURLY);
                    //3：获取广告计划信息数据
                    //reportService.getAdvertiserPlanReport(token, finalGetDate, finalGetDate, CtopAdConstant.BYTEDANCE_REPORT_TYPE_HOURLY);
                    //4: 获取广告创意信息数据
                    //reportService.getAdvertiserCreativeReport(token, finalGetDate, finalGetDate, CtopAdConstant.BYTEDANCE_REPORT_TYPE_HOURLY);
                }

            });

        });
        log.info("头条时报数据获取结束");
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @GetMapping("formatYddData")
    public Map<String, Object> formatYddData() throws Exception {
        Map<String, Object> result = new HashMap<>();
        //清洗关于缘多多数据
        //1:查询缘多多相关的用户数据
        QueryWrapper<UserAllocation> yddWrapper = new QueryWrapper<>();
        yddWrapper.eq("project_id", 113);
        List<UserAllocation> yddallocations = userAllocationService.list(yddWrapper);
        if (null != yddallocations && yddallocations.size() > 0) {
            yddallocations.forEach(allocation -> {
                //根据accountId和时间，查询相关的日报表信息
                QueryWrapper<BytedancePlanDailyReport> queryWrapper = new QueryWrapper<>();
                queryWrapper.eq("advertiser_id", allocation.getAccountId())
                //.eq("stat_datetime",dateString)
                ;
                List<BytedancePlanDailyReport> bytedancePlanDailyReports = planDailyReportService.list(queryWrapper);
                if (null != bytedancePlanDailyReports && bytedancePlanDailyReports.size() > 0) {
                    bytedancePlanDailyReports.forEach(report -> {
                        String adName = report.getAdName();
                        String[] tags = adName.split("-");
                        report.setChannelCode(tags[0]);
                        planDailyReportService.updateById(report);
                    });
                }
            });
        }

        //清洗关于缘多多数据
        //1:查询缘多多相关的用户数据
        QueryWrapper<UserAllocation> dsjyWrapper = new QueryWrapper<>();
        yddWrapper.eq("project_id", 112);
        List<UserAllocation> dsjyAllocations = userAllocationService.list(dsjyWrapper);
        if (null != dsjyAllocations && dsjyAllocations.size() > 0) {
            dsjyAllocations.forEach(allocation -> {
                //根据accountId和时间，查询相关的日报表信息
                QueryWrapper<BytedancePlanDailyReport> queryWrapper = new QueryWrapper<>();
                queryWrapper.eq("advertiser_id", allocation.getAccountId())
                //.eq("stat_datetime",dateString)
                ;
                List<BytedancePlanDailyReport> bytedancePlanDailyReports = planDailyReportService.list(queryWrapper);
                if (null != bytedancePlanDailyReports && bytedancePlanDailyReports.size() > 0) {
                    bytedancePlanDailyReports.forEach(report -> {
                        String adName = report.getAdName();
                        String[] tags = adName.split("-");
                        report.setChannelCode(tags[0]);
                        planDailyReportService.updateById(report);
                    });
                }
            });
        }

        //清洗关于缘多多数据
        //1:查询缘多多相关的用户数据
        QueryWrapper<UserAllocation> fjyhWrapper = new QueryWrapper<>();
        yddWrapper.eq("project_id", 222);
        List<UserAllocation> fjyhAllocations = userAllocationService.list(fjyhWrapper);
        if (null != fjyhAllocations && fjyhAllocations.size() > 0) {
            fjyhAllocations.forEach(allocation -> {
                //根据accountId和时间，查询相关的日报表信息
                QueryWrapper<BytedancePlanDailyReport> queryWrapper = new QueryWrapper<>();
                queryWrapper.eq("advertiser_id", allocation.getAccountId())
                //.eq("stat_datetime",dateString)
                ;
                List<BytedancePlanDailyReport> bytedancePlanDailyReports = planDailyReportService.list(queryWrapper);
                if (null != bytedancePlanDailyReports && bytedancePlanDailyReports.size() > 0) {
                    bytedancePlanDailyReports.forEach(report -> {
                        String adName = report.getAdName();
                        String[] tags = adName.split("-");
                        report.setChannelCode(tags[0]);
                        planDailyReportService.updateById(report);
                    });
                }
            });
        }
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }
}
