package cn.com.ctop.common.module.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 素材信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-10-11
 */
@Data
@TableName("ctop_material_info")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_material_info对象", description = "素材信息")
public class MaterialInfo {

    /**
     * id
     */
    @TableId
    @ApiModelProperty(value = "id")
    private String id;
    /**
     * code
     */
    @Excel(name = "code", width = 15)
    @ApiModelProperty(value = "code")
    private String code;
    private String watermarkCode;
    /**
     * url
     */
    @Excel(name = "url", width = 15)
    @ApiModelProperty(value = "url")
    private String url;

    /**
     * 水印素材链接
     */
    private String watermarkUrl;

    private String type;
    /**
     * 审核人id
     */
    private String auditorId;
    /**
     * status
     * <p>
     * 0-待审核 1-审核通过 2-审核拒绝
     */
    @Excel(name = "status", width = 15)
    @ApiModelProperty(value = "status")
    private Integer status;
    /**
     * userId
     */
    @Excel(name = "user_id", width = 15)
    @ApiModelProperty(value = "user_id")
    private String userId;


    private String materialDescribe;


    private Long projectId;

    /**
     * 素材名称
     */
    private String materialName;

    /**
     * 水印素材名称
     */
    private String watermarkMaterialName;

    /**
     * 拒绝原因
     */
    private String refuseReason;
    /**
     * 拒绝上传文件
     */
    private String refuseFile;

    /**
     * 创意文案
     */
    private String creativeCopywriter;

    /**
     * 是否优秀素材
     */
    private Integer excellent;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Object createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date updateTime;

    private Integer toutiaoEffiType; //判断是否为头条有效素材0否_1是

    private Integer kuaishouEffiType; //判断是否为快手有效素材0否_1是

}
