package cn.com.ctop.toutiao.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 今日头条预算模板信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-07-22
 */
@Data
@TableName("ctop_bytedance_budget_template")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_budget_template对象", description = "今日头条预算模板信息")
public class ByteDanceBudgetTemplate {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 平台广告主id
     * advertiserId
     */
    @Excel(name = "平台广告主id", width = 15)
    @ApiModelProperty(value = "advertiser_id")
    private String advertiserId;
    /**
     * 模板名称
     */
    @Excel(name = "模板名称", width = 15)
    @ApiModelProperty(value = "模板名称")
    private String name;
    /**
     * bidType
     */
    @Excel(name = "bidType", width = 15)
    @ApiModelProperty(value = "bidType")
    private String bidType;
    /**
     * flowControlMode
     */
    @Excel(name = "flowControlMode", width = 15)
    @ApiModelProperty(value = "flowControlMode")
    private String flowControlMode;
    /**
     * budgetPrice
     */
    @Excel(name = "budgetPrice", width = 15)
    @ApiModelProperty(value = "budgetPrice")
    private String budgetPrice;
    /**
     * budgetMode
     */
    @Excel(name = "budgetPriceMode", width = 15)
    @ApiModelProperty(value = "budgetPriceMode")
    private String budgetPriceMode;
    /**
     * flowDateType
     */
    @Excel(name = "flowDateType", width = 15)
    @ApiModelProperty(value = "flowDateType")
    private String flowDateType;
    /**
     * startDate
     */
    @Excel(name = "开始日期", width = 15)
    @ApiModelProperty(value = "startDate")
    private String startDate;
    /**
     * endDate
     */
    @Excel(name = "结束日子", width = 15)
    @ApiModelProperty(value = "endDate")
    private String endDate;
    /**
     * dateQuantum
     */
    @Excel(name = "dateQuantum", width = 15)
    @ApiModelProperty(value = "dateQuantum")
    private String dateQuantum;
    /**
     * dateQuantumRange
     */
    @Excel(name = "dateQuantumRange", width = 15)
    @ApiModelProperty(value = "dateQuantumRange")
    private String dateQuantumRange;
    /**
     * priceType
     */
    @Excel(name = "priceType", width = 15)
    @ApiModelProperty(value = "priceType")
    private String priceType;
    /**
     * convertPrice
     */
    @Excel(name = "转化出价", width = 15)
    @ApiModelProperty(value = "convertPrice")
    private String convertPrice;
    /**
     * filterType
     */
    @Excel(name = "filterType", width = 15)
    @ApiModelProperty(value = "filterType")
    private String filterType;
    /**
     * status
     */
    @Excel(name = "status", width = 15)
    @ApiModelProperty(value = "status")
    private Integer status;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;

    private String createBy;
    private String updateBy;

    public ByteDanceBudgetTemplate() {
    }
}
