package cn.com.ctop.toutiao.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 今日头条广告组模板信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-07-22
 */
@Data
@TableName("ctop_bytedance_campaign_template")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_campaign_template对象", description = "今日头条广告组模板信息")
public class ByteDanceCampaignTemplate {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 平台广告主id
     * advertiserId
     */
    @ApiModelProperty(value = "advertiser_id")
    private String advertiserId;
    /**
     * 推广目的
     */
    @Excel(name = "推广目的", width = 15)
    @ApiModelProperty(value = "推广目的")
    @Dict(dicCode = "toutiao_promotion_purpose_type")
    private String promotionPurpose;
    /**
     * 投放方式
     */
    @Excel(name = "投放方式", width = 15)
    @ApiModelProperty(value = "投放方式")
    @Dict(dicCode = "toutiao_budget_mode")
    private String campaignBudget;
    /**
     * 日预算
     */
    @Excel(name = "日预算", width = 15)
    @ApiModelProperty(value = "日预算")
    private String budgetDaily;
    /**
     * 广告组名称
     */
    @Excel(name = "广告组名称", width = 15)
    @ApiModelProperty(value = "广告组名称")
    private String campaignName;
    /**
     * 模板状态
     */
    @Excel(name = "模板状态", width = 15)
    @ApiModelProperty(value = "模板状态")
    private Integer status;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;

    public ByteDanceCampaignTemplate() {
    }
}
