package cn.com.ctop.toutiao.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * @Description: 广告创意模板
 * @Author: jeecg-boot
 * @Date: 2019-07-29
 * @Version: V1.0
 */
@Data
@TableName("ctop_bytedance_creative_template")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_creative_template对象", description = "广告创意模板")
public class ByteDanceCreativeTemplate {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 广告计划id
     */
    @Excel(name = "广告计划id", width = 15)
    @ApiModelProperty(value = "广告计划id")
    private Integer adId;
    /**
     * 视频id
     */
    @Excel(name = "视频id", width = 15)
    @ApiModelProperty(value = "视频id")
    private Integer videoId;
    /**
     * 图片id
     */
    @Excel(name = "图片id", width = 15)
    @ApiModelProperty(value = "图片id")
    private Integer imageId;
    /**
     * 创意文案
     */
    @Excel(name = "创意文案", width = 15)
    @ApiModelProperty(value = "创意文案")
    private String createText;
    /**
     * 来源
     */
    @Excel(name = "来源", width = 15)
    @ApiModelProperty(value = "来源")
    private String source;
    /**
     * 图片生成视频
     */
    @Excel(name = "图片生成视频", width = 15)
    @ApiModelProperty(value = "图片生成视频")
    private String imageToVideo;
    /**
     * 最优衍生计划
     */
    @Excel(name = "最优衍生计划", width = 15)
    @ApiModelProperty(value = "最优衍生计划")
    private String derivativePlan;
    /**
     * 是否开启广告评论
     */
    @Excel(name = "是否开启广告评论", width = 15)
    @ApiModelProperty(value = "是否开启广告评论")
    private String commentOpen;
    /**
     * 展现方式
     */
    @Excel(name = "展现方式", width = 15)
    @ApiModelProperty(value = "展现方式")
    private String presentType;
    /**
     * 创意分类
     */
    @Excel(name = "创意分类", width = 15)
    @ApiModelProperty(value = "创意分类")
    private String creativeCategory;
    /**
     * 创意标签
     */
    @Excel(name = "创意标签", width = 15)
    @ApiModelProperty(value = "创意标签")
    private String createTitle;
    /**
     * 第三方监测链接展示
     */
    @Excel(name = "第三方监测链接展示", width = 15)
    @ApiModelProperty(value = "第三方监测链接展示")
    private String monitorLinkDisplay;
    /**
     * 第三方监测链接点击
     */
    @Excel(name = "第三方监测链接点击", width = 15)
    @ApiModelProperty(value = "第三方监测链接点击")
    private String monitorLinkClick;
    /**
     * 第三方监测链接视频播放
     */
    @Excel(name = "第三方监测链接视频播放", width = 15)
    @ApiModelProperty(value = "第三方监测链接视频播放")
    private String monitorLinkPlay;
    /**
     * 第三方监测链接视频播完
     */
    @Excel(name = "第三方监测链接视频播完", width = 15)
    @ApiModelProperty(value = "第三方监测链接视频播完")
    private String monitorLinkPlayed;
    /**
     * status
     */
    @Excel(name = "status", width = 15)
    @ApiModelProperty(value = "status")
    private Integer status;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;

    public ByteDanceCreativeTemplate() {
    }
}
