package cn.com.ctop.toutiao.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 应用下载详情页信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-09-27
 */
@Data
@TableName("ctop_bytedance_app_download_detail_page")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_app_download_detail_page对象", description = "应用下载详情页信息")
public class BytedanceAppDownloadDetailPage {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * name
     */
    @Excel(name = "name", width = 15)
    @ApiModelProperty(value = "name")
    private String name;
    /**
     * 应用下载链接
     */
    @Excel(name = "应用下载链接", width = 15)
    @ApiModelProperty(value = "应用下载链接")
    private String downloadUrl;
    /**
     * 应用名
     */
    @Excel(name = "应用名", width = 15)
    @ApiModelProperty(value = "应用名")
    private String appName;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
