package cn.com.ctop.toutiao.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * 创意模板
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-09-27
 */
@Data
@TableName("ctop_bytedance_creative_launch_template")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_creative_launch_template对象", description = "创意模板")
public class BytedanceCreativeLaunchTemplate {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 模板名称
     */
    @Excel(name = "模板名称", width = 15)
    @ApiModelProperty(value = "模板名称")
    private String name;
    /**
     * 是否关闭评论
     */
    @Excel(name = "是否关闭评论", width = 15)
    @ApiModelProperty(value = "是否关闭评论")
    private Integer commentDisable;
    /**
     * 是否关闭视频详情页落地页
     */
    @Excel(name = "是否关闭视频详情页落地页", width = 15)
    @ApiModelProperty(value = "是否关闭视频详情页落地页")
    private Integer closeVideoDetail;
    /**
     * 创意展现方式
     */
    @Excel(name = "创意展现方式", width = 15)
    @ApiModelProperty(value = "创意展现方式")
    private String creativeDisplayMode;
    /**
     * 是否使用优选广告位
     */
    @Excel(name = "是否使用优选广告位", width = 15)
    @ApiModelProperty(value = "是否使用优选广告位")
    private Integer smartInventory;
    /**
     * 场景广告位
     */
    @Excel(name = "场景广告位", width = 15)
    @ApiModelProperty(value = "场景广告位")
    private String sceneInventory;
    /**
     * 是否开启衍生计划
     */
    @Excel(name = "是否开启衍生计划", width = 15)
    @ApiModelProperty(value = "是否开启衍生计划")
    private String generateDerivedAd;
    /**
     * 创意投放位置
     */
    @Excel(name = "创意投放位置", width = 15)
    @ApiModelProperty(value = "创意投放位置")
    private String inventoryType;
    /**
     * 创意分类
     */
    @Excel(name = "创意分类", width = 100)
    @ApiModelProperty(value = "创意分类")
    private String thirdIndustryId;

    @Excel(name = "创建时间")
    @ApiModelProperty(value = "创建时间")
    private String createTime;

    @Excel(name = "修改时间")
    @ApiModelProperty(value = "修改时间")
    private String updateTime;

    @Excel(name = "创意标签")
    @ApiModelProperty(value = "创意标签")
    private String adKeywords;

    private String userId;

    @Excel(name = "广告位置")
    @ApiModelProperty(value = "广告位置")
    private String advertiseLocation;

}
