package cn.com.ctop.toutiao.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * @Description: 投放目标模板信息
 * @Author: jeecg-boot
 * @Date: 2019-07-23
 * @Version: V1.0
 */
@Data
@TableName("ctop_bytedance_delivery_target_template")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_delivery_target_template对象", description = "投放目标模板信息")
public class BytedanceDeliveryTargetTemplate {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 平台广告主id
     * advertiserId
     */
    @Excel(name = "平台广告主id", width = 15)
    @ApiModelProperty(value = "advertiser_id")
    private String advertiserId;
    /**
     * 投放范围
     */
    @Excel(name = "投放范围", width = 15)
    @ApiModelProperty(value = "delivery_range")
    private String deliveryRange;
    /**
     * 投放范围
     */
    @Excel(name = "应用下载类型", width = 32)
    @ApiModelProperty(value = "download_mode")
    private String downloadMode;

    /**
     * 模板名称
     */
    @Excel(name = "模板名称", width = 15)
    @ApiModelProperty(value = "模板名称")
    private String name;
    /**
     * 投放目标
     */
    @Excel(name = "投放目标", width = 15)
    @ApiModelProperty(value = "投放目标")
    @Dict(dicCode = "toutiao_delivery_target_type")
    private String deliveryTarget;
    /**
     * 下载方式
     */
    @Excel(name = "下载方式", width = 15)
    @ApiModelProperty(value = "下载方式")
    @Dict(dicCode = "toutiao_dowload_type")
    private String downloadType;
    /**
     * 下载链接
     */
    @Excel(name = "下载链接", width = 15)
    @ApiModelProperty(value = "下载链接")
    private String downloadUrl;
    /**
     * 落地页链接
     */
    @Excel(name = "落地页链接", width = 15)
    @ApiModelProperty(value = "落地页链接")
    private String externalUrl;
    /**
     * 转化目标
     */
    @Excel(name = "转化目标", width = 15)
    @ApiModelProperty(value = "转化目标")
    private String convertTarget;
    /**
     * 应用包名
     */
    @Excel(name = "应用包名", width = 15)
    @ApiModelProperty(value = "应用包名")
    private String packageName;
    /**
     * 直达链接启用状态
     */
    @Excel(name = "直达链接启用状态", width = 15)
    @ApiModelProperty(value = "直达链接启用状态")
    private String openUrlStatus;
    /**
     * 直达链接生成方式
     */
    @Excel(name = "直达链接生成方式", width = 15)
    @ApiModelProperty(value = "直达链接生成方式")
    private String openUrlCreateMode;
    /**
     * 跳转app链接
     */
    @Excel(name = "跳转app链接", width = 15)
    @ApiModelProperty(value = "跳转app链接")
    private String redirectUrl;
    /**
     * status
     */
    @Excel(name = "status", width = 15)
    @ApiModelProperty(value = "status")
    private Integer status;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;

    @TableField(exist = false)
    private Long urlId;

    public BytedanceDeliveryTargetTemplate() {
    }
}
