package cn.com.ctop.toutiao.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * @Description: 今日头条链接信息
 * @Author: jeecg-boot
 * @Date: 2019-08-06
 * @Version: V1.0
 */
@Data
@TableName("ctop_bytedance_url_info")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_url_info对象", description = "今日头条链接信息")
public class BytedanceUrlInfo {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * advertiserId
     */
    @Excel(name = "advertiserId", width = 15)
    @ApiModelProperty(value = "advertiserId")
    private String advertiserId;
    /**
     * 描述信息
     */
    @Excel(name = "名称", width = 15)
    @ApiModelProperty(value = "描述信息")
    private String name;
    /**
     * 链接地址
     */
    @Excel(name = "链接地址", width = 15)
    @ApiModelProperty(value = "链接地址")
    private String url;
    /**
     * 应用包名
     */
    @Excel(name = "应用包名", width = 15)
    @ApiModelProperty(value = "应用包名")
    private String packageName;
    /**
     * 链接类型
     */
    @Excel(name = "链接类型", width = 15)
    @ApiModelProperty(value = "链接类型")
    private String type;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
