package cn.com.ctop.performanceappraisal.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 优化师角色关系表
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-12-17
 */
@Data
@TableName("ctop_optimizer_role_info")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_optimizer_role_info对象", description = "优化师角色关系表")
public class OptimizerRoleInfo {

    /**
     * id
     */
    @TableId(type = IdType.UUID)
    @ApiModelProperty(value = "id")
    private Integer id;
    /**
     * 部门代码
     */
    @Excel(name = "部门代码", width = 15)
    @ApiModelProperty(value = "部门代码")
    private String orgCode;
    /**
     * 角色类型 1：运营经理 2：运营专员
     */
    @Excel(name = "角色类型 1：运营经理 2：运营专员", width = 15)
    @ApiModelProperty(value = "角色类型 1：运营经理 2：运营专员")
    @Dict(dicCode = "optimizer_type")
    private Integer type;
    /**
     * 用户id
     */
    @Excel(name = "用户id", width = 15)
    @ApiModelProperty(value = "用户id")
    @Dict(dicCode = "id", dictTable = "sys_user", dicText = "realname")
    private String userId;
    private String realname;
    /**
     * 归属人id
     */
    @Excel(name = "归属人id", width = 15)
    @ApiModelProperty(value = "归属人id")
    @Dict(dicCode = "id", dictTable = "sys_user", dicText = "realname")
    private String belongerId;
    /**
     * enabled
     */
    @Excel(name = "enabled", width = 15)
    @ApiModelProperty(value = "enabled")
    @Dict(dicCode = "valid_status")
    private Integer enabled;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
