package cn.com.ctop.performanceappraisal.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 设计师季度绩效表
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-12-10
 */
@Data
@TableName("ctop_performance")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_performance对象", description = "设计师季度绩效表")
public class Performance {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * sys_user的主键id
     */
    @Excel(name = "sys_user的主键id", width = 15)
    @ApiModelProperty(value = "sys_user的主键id")
    @Dict(dicCode = "id", dictTable = "sys_user", dicText = "realname")
    private String userId;
    /**
     * sys_role的主键id
     */
    @Excel(name = "sys_role的主键id", width = 15)
    @ApiModelProperty(value = "sys_role的主键id")
    @Dict(dicCode = "id", dictTable = "sys_role", dicText = "role_name")
    private String roleId;
    /**
     * 年度
     */
    @Excel(name = "年度", width = 15)
    @ApiModelProperty(value = "年度")
    private Integer year;
    /**
     * 季度
     */
    @Excel(name = "季度", width = 15)
    @ApiModelProperty(value = "季度")
    private Integer quarter;
    /**
     * 绩效统计开始时间
     */
    @Excel(name = "绩效统计开始时间", width = 15)
    @ApiModelProperty(value = "绩效统计开始时间")
    private String startTime;
    /**
     * 绩效统计结束时间
     */
    @Excel(name = "绩效统计结束时间", width = 15)
    @ApiModelProperty(value = "绩效统计结束时间")
    private String endTime;
    /**
     * 总消耗(单位元)
     */
    @Excel(name = "总消耗(单位元)", width = 15)
    @ApiModelProperty(value = "总消耗(单位元)")
    private java.math.BigDecimal totalCost;
    /**
     * 总绩效(单位元)
     */
    @Excel(name = "总绩效(单位元)", width = 15)
    @ApiModelProperty(value = "总绩效(单位元)")
    private java.math.BigDecimal totalPerformance;
    /**
     * 提点比例
     */
    @Excel(name = "提点比例", width = 15)
    @ApiModelProperty(value = "提点比例")
    private java.math.BigDecimal commissionRate;
    /**
     * 角色提成比例
     */
    @Excel(name = "角色提成比例", width = 15)
    @ApiModelProperty(value = "角色提成比例")
    private java.math.BigDecimal roleCommissionRate;
    /**
     * 视频有效率
     */
    @Excel(name = "视频有效率", width = 15)
    @ApiModelProperty(value = "视频有效率")
    private java.math.BigDecimal videoEfficiency;
    /**
     * 1_快手2_抖音
     */
    @Excel(name = "媒体类型1_头条2_快手", width = 15)
    @ApiModelProperty(value = "媒体类型1_头条2_快手")
    @Dict(dicCode = "app_type")
    private Integer appType;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
}
