package cn.com.ctop.performanceappraisal.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 角色提成比例
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-12-10
 */
@Data
@TableName("ctop_role_performance_commission")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_role_performance_commission对象", description = "角色提成比例")
public class RolePerformanceCommission {

    /**
     * 主键id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "主键id")
    private Long id;
    /**
     * sys_role的主键id
     */
    @Excel(name = "sys_role的主键id", width = 15)
    @ApiModelProperty(value = "sys_role的主键id")
    @Dict(dicCode = "id", dictTable = "sys_role", dicText = "role_name")
    private String roleId;
    /**
     * 角色提成比例
     */
    @Excel(name = "角色提成比例", width = 15)
    @ApiModelProperty(value = "角色提成比例")
    private java.math.BigDecimal roleCommissionRate;
    /**
     * 是否可用 1：可用 2：不可用
     */
    @Excel(name = "是否可用", width = 15)
    @ApiModelProperty(value = "是否可用 1：可用 2：不可用")
    @Dict(dicCode = "valid_status")
    private Integer enabled;
    /**
     * 1:快手  2：头条
     */
    @Excel(name = "媒体类型1_头条2_快手", width = 15)
    @ApiModelProperty(value = "媒体类型1_头条2_快手")
    @Dict(dicCode = "media_type")
    private Integer appType;

    @Excel(name = "是否有平面", width = 15)
    @ApiModelProperty(value = "是否有平面")
    @Dict(dicCode = "has_plane")
    private Integer hasPlane;
    /**
     * 开始时间
     */
    @ApiModelProperty(value = "开始时间")
    private Date createTime;
    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
}
