package cn.com.ctop.userefficientvideomap.mapper;

import cn.com.ctop.userefficientvideomap.entity.*;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.util.List;

/**
 * 有效视频与角色对应表
 * @author: jeecg-boot
 * @date:   2019-12-16
 * @cersion: V1.0
 */
@Component
public interface UserEfficientVideoMapMapper extends BaseMapper<UserEfficientVideoMap> {

    List<EffiVideoDTO> getUserVideoMap(@Param("startDate")String startDate, @Param("endDate")String endDate, @Param("startCalcDate")String startCalcDate, @Param("endCalcDate")String endCalcDate);

    int getEffiVideoCountBySignature(@Param("signature")String signature, @Param("appType")Integer appType);

    int getEffiVideoCountByUserId(@Param("appType") int appType, @Param("year") int year, @Param("quarter") int quarter, @Param("userId") String userId, @Param("roleId") String roleId);

    int getQuarterMaterialCountByUserId(@Param("roleCode")String roleCode, @Param("startTime")String startTime, @Param("endTime")String endTime, @Param("userId")String userId);

    BigDecimal getTotalCostByClipId(@Param("userId")String userId, @Param("startDate")String startDate, @Param("endDate")String endDate);

    BigDecimal getTotalCostByShotId(@Param("userId")String userId, @Param("startDate")String startDate, @Param("endDate")String endDate);

    BigDecimal getTotalCostByPlanId(@Param("userId")String userId, @Param("startDate")String startDate, @Param("endDate")String endDate);

    BigDecimal getTotalCostByPlaneId(@Param("userId")String userId, @Param("startDate")String startDate, @Param("endDate")String endDate);

    BigDecimal getProjectTotalCostByUserId(@Param("userId")String userId, @Param("startDate")String startDate, @Param("endDate")String endDate);

    List<ProjectDTO> getProjectsByUserId(@Param("userId")String userId);

    int getPlaneCountByProjectId(@Param("projectId")Long projectId);

    int getPlaneCountByUserId(@Param("userId")String userId);

    List<DesignMaterialInfo> designMaterialInfoList(@Param("roleCode")String roleCode, @Param("userId")String userId, @Param("startDate")String startDate, @Param("endDate")String endDate);

    List<DesignMaterialInfo> getMaterialAccountInfoByMaterialId(@Param("materialId")String materialId, @Param("startDate")String startDate, @Param("endDate")String endDate);

    List<ProjectDTO> getProjects(@Param("mediaId")String mediaId);

    BigDecimal getProjectQuarterCostById(@Param("startDate")String startDate, @Param("endDate")String endDate, @Param("projectId")Long projectId);

    List<UserDto2> getPlaneByProjectId(@Param("projectId")Long projectId);

    List<UserDto2> getKuaishouDesignLeaderList();

    List<UserDto2> getKuaishouPlanList();

    List<UserDto2> getKuaishouShotList();

    List<UserDto2> getKuaishouClipList();

    List<UserDto2> getToutiaoPlanList();

    List<UserDto2> getToutiaoShotList();

    List<UserDto2> getToutiaoClipList();

    List<UserDto2> getToutiaoDesignLeaderList();

    List<String> getClip(@Param("depId")String depId);

    BigDecimal getClipQuarterCost(@Param("appType") int appType, @Param("quarter") int quarter, @Param("year") int year, @Param("userId") String userId);

    //头条有效视频计算sql
    List<EffiVideoDTO> getToutiaoUserVideoMap(@Param("startDate") String startDate, @Param("endDate") String endDate, @Param("startCalcDate") String startCalcDate, @Param("endCalcDate") String endCalcDate);

    BigDecimal toutiaoGetTotalCostByClipId(@Param("userId") String userId, @Param("startDate") String startDate, @Param("endDate") String endDate);

    BigDecimal toutiaoGetTotalCostByShotId(@Param("userId") String userId, @Param("startDate") String startDate, @Param("endDate") String endDate);

    BigDecimal toutiaoGetTotalCostByPlanId(@Param("userId") String userId, @Param("startDate") String startDate, @Param("endDate") String endDate);

    BigDecimal getQuarterPerformance(@Param("userId") String userId, @Param("year") int year, @Param("quarter") int quarter, @Param("appType") int appType);

    BigDecimal getQuarterCost(@Param("userId") String userId, @Param("year") int year, @Param("quarter") int quarter, @Param("appType") int appType);

    String getOrgCodeByProjectId(@Param("projectId") Long projectId);

    SysRole getRoleIdByUserId(@Param("userId") String userId);

    String getDepartIdByUserId(@Param("userId") String userId);

    List<UserDto2> getUserListByDepartId(@Param("departId") String departId);

    String getDepartNameByUserId(@Param("userId") String userId);

    String getParentIdByDepartId(@Param("departId") String departId);

    List<PlaneProjectCostDTO> getPlanePerformanceInfo(@Param("appType") int appType, @Param("year") int year, @Param("quarter") int quarter, @Param("userId") String userId);

    List<UserDto2> getUserPerformanceList(@Param("appType") Integer appType, @Param("year") Integer year, @Param("quarter") Integer quarter);

    List<String> getUserIdListByDepId(@Param("depId") String depId);

    void updateKuaishouEffiType(@Param("kuaishouEffiType") Integer kuaishouEffiType, @Param("signature") String signature);

    void updateToutiaoEffiType(@Param("toutiaoEffiType") Integer toutiaoEffiType, @Param("signature") String signature);

    List<UserDto2> getKuaishouDepartUserInfo();

    List<UserDto2> getToutiaoDepartUserInfo();

    //根据天数的区间获取userId获取有效视频数量
    Integer getEffiVideoCountByCalcDate(@Param("startDate") String startDate, @Param("endDate") String endDate, @Param("roleId") String roleId, @Param("userId") String userId, @Param("appType") Integer appType);

}

